//
//  ITProxy.h
//  JiT
//
//  Created by Peter Kristensen on 20/09/06.
//  Copyright 2006 Lucky Software. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import "JiTServerManagedObject.h"

@interface ITProxy : NSObject <ITClientObject> {
	id <JiTServerObject> serverObject;
	NSMutableDictionary *cachedValues;
    NSMutableSet *didKeys;
    NSMutableSet *willKeys;
    NSURL *serverObjectURI;
}

+ (id)proxyForServerObject:(id <JiTServerObject>)obj;
- (NSURL *)serverObjectURI;

- (id <JiTServerObject>)serverObject;
- (id)initWithServerObject:(id <JiTServerObject>)obj;

- (id)serverValueForKey:(NSString *)key;
- (void)setValue:(id)val forServerKey:(NSString *)key;

- (id)cachedValueForKey:(NSString *)key;

- (void)willChangeFromServer:(NSString *)key;
- (void)didChangeFromServer:(NSString *)key;


@end
